(function(Drupal, drupalSettings) {
  Drupal.behaviors.DkanJsonFormTweakCloseDetails = {
    attach: function (context, settings) {
      once('dkanJsonFormTweakCloseDetails', '.dkan-json-form-close-button', context).forEach(function (closeButton){
        closeButton.addEventListener('click', function (event) {
          let button_status = closeButton.getAttribute('data-buttonstatus');
          if (button_status === 'opened') {
            closeButton.innerHTML = drupalSettings.dkan_json_form_tweak.open_label;
            closeButton.setAttribute('data-buttonstatus', 'closed');
          }
          else {
            closeButton.innerHTML = drupalSettings.dkan_json_form_tweak.close_label;
            closeButton.setAttribute('data-buttonstatus', 'opened');
          }
          // ToDo: two times parent because of dkan-json-form-close-button.html.twig structure,
          // should be revisited
          let details = this.parentElement.parentElement.querySelectorAll('details');
          details.forEach(function (detail) {
            if (button_status === 'opened') {
              detail.removeAttribute('open');
            }
            else {
              detail.setAttribute('open', 'open');
            }
          })
        });
      });
    }
  }
} (Drupal, drupalSettings));
