(function(Drupal) {
  Drupal.behaviors.DkanJsonFormTweakNavigation = {
    attach: function (context, settings) {
      let jsonSubForms = document.querySelectorAll('[data-json-form-navigation="true"]');
      if (jsonSubForms.length === 0) {
        let jsonForm = document.querySelectorAll('#edit-field-json-metadata-wrapper > *:not(.dkan-json-form-navigation-wrapper)');
        let jsonFormNavigation = document.querySelectorAll('.dkan-json-form-navigation > *');

        jsonFormNavigation.forEach(function (navitem, index) {
          navitem.addEventListener('click', function (event) {
            focusOnNavigationElement(jsonForm, index);
          });
        });
      }
      else {
        jsonSubForms.forEach(function (subform, index) {
          let jsonSubForm = subform.querySelectorAll(':scope > .details-wrapper > *:not(.dkan-json-form-navigation-wrapper):not(.alert)');
          let jsonSubformNavigation = subform.querySelectorAll('.dkan-json-form-navigation-wrapper .dkan-json-form-navigation > *');
          jsonSubformNavigation.forEach(function (subnavitem, index) {
            subnavitem.addEventListener('click', function (event) {
              focusOnNavigationElement(jsonSubForm, index);
            });
          });
        })
      }

      function focusOnNavigationElement(form, index) {
        let focusable = form[index].querySelectorAll('button, [href], input, select, textarea, [tabindex="0"]');
        if (focusable.length > 0) {
          focusable[0].focus();
        }
      }
    }
  }
} (Drupal));

