<?php

namespace Drupal\dkan_json_form_tweak;

class SchemaUiHandler extends \Drupal\json_form_widget\SchemaUiHandler {

  public function applySchemaUi(mixed $form)
  {
    // handle sub schemas like distribution, publisher etc.
    // ToDo: Attention - this currently only handles the hidden widget spec correctly, as DKAN can currently
    // not handle references in sub schemas (like publisher in distribution)
    if (isset($form['data']['data'])) {
      $schema_ui = $this->schemaUi->data->properties ?? $this->schemaUi;
      foreach ((array)$schema_ui as $property => $spec) {
        // Handle property specification from schema UI.
        $form['data']['data'][$property] = $this->handlePropertySpec($property, $spec, $form['data']['data'][$property]);
      }
    }
    return parent::applySchemaUi($form);
  }
}
