<?php

namespace Drupal\dkan_json_form_tweak;

class ValueHandler extends \Drupal\json_form_widget\ValueHandler {

  protected function getObjectInArrayData($formValues, $property, $schema)
  {
    $data = parent::getObjectInArrayData($formValues, $property, $schema);
    $rekey = FALSE;
    if (isset($formValues[$property][$property])) {
      foreach ($formValues[$property][$property] as $key => $item) {
        $remove = isset($formValues[$property][$property][$key][$property]['remove_item']) && (bool) $formValues[$property][$property][$key][$property]['remove_item'] === TRUE;
        if ($remove) {
          unset($data[$key]);
          $rekey = TRUE;
        }
      }
    }
    if ($rekey) {
      return array_values($data);
    }
    return $data;
  }

  protected function flattenArraysInArrays($value) {
    $remove = isset($value['remove_item']) && (bool) $value['remove_item'] === TRUE;
    if ($remove) {
      return [];
    }
    if (isset($value['value'])) {
      $value = $value['value'];
    }
    return parent::flattenArraysInArrays($value);
  }

}
